﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using MvcSecurityExample.Models;
using System.Web.Helpers;
using System.Data;

namespace MvcSecurityExample.Provider
{
    public class CustomMembershipProvider : MembershipProvider
    {
        /// <summary>
        /// Проверка пользователя
        /// </summary>
        public override bool ValidateUser(string username, string password)
        {
            MvcSecurityExampleModelContainer db = new MvcSecurityExampleModelContainer();
            bool Result = false;

            //Поиск пользователя по имени пользователя
            User user = db.Users.FirstOrDefault(x => x.Login == username);
            if (user != null)
            {
                //Если пользователь найден, проверяется пароль
                Result = CheckPassword(user, password);
            }

            return Result;
        }


        public override bool ChangePassword(string username, string oldPassword, string newPassword)
        {
            MvcSecurityExampleModelContainer db = new MvcSecurityExampleModelContainer();

            //Если пользователь с таким паролем существует
            bool Result = ValidateUser(username, oldPassword);
            if (Result)
            {
                try
                {
                    //Получение пользователя
                    User user = db.Users.Single(x => x.Login == username);

                    //Создание и сохранение хэша пароля
                    string passwordHash = HashPassword(newPassword);
                    user.Password = passwordHash;

                    //Изменение записи в БД
                    db.Users.Attach(user);
                    db.ObjectStateManager.ChangeObjectState(user, EntityState.Modified);
                    db.SaveChanges();

                    Result = true;
                }
                catch
                {
                    Result = false;
                }
            }

            return Result;
        }

        public static string HashPassword(string password)
        {
            string Result = Crypto.HashPassword(password);
            return Result;
        }

        public static bool CheckPassword(User user, string password)
        {
            string hashedPassword = user.Password;
            bool Result = Crypto.VerifyHashedPassword(hashedPassword, password);
            return Result;
        }

        public static User GetUser(string username)
        {
            MvcSecurityExampleModelContainer db = new MvcSecurityExampleModelContainer();

            var user = db.Users.FirstOrDefault(
                x => x.Login == username.Trim()
                );

            return user;
        }

        public override string ApplicationName
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }


        public override bool ChangePasswordQuestionAndAnswer(string username, string password, string newPasswordQuestion, string newPasswordAnswer)
        {
            throw new NotImplementedException();
        }

        public override MembershipUser CreateUser(string username, string password, string email, string passwordQuestion, string passwordAnswer, bool isApproved, object providerUserKey, out MembershipCreateStatus status)
        {
            throw new NotImplementedException();
        }

        public override bool DeleteUser(string username, bool deleteAllRelatedData)
        {
            throw new NotImplementedException();
        }

        public override bool EnablePasswordReset
        {
            get { throw new NotImplementedException(); }
        }

        public override bool EnablePasswordRetrieval
        {
            get { throw new NotImplementedException(); }
        }

        public override MembershipUserCollection FindUsersByEmail(string emailToMatch, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override MembershipUserCollection FindUsersByName(string usernameToMatch, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override MembershipUserCollection GetAllUsers(int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override int GetNumberOfUsersOnline()
        {
            throw new NotImplementedException();
        }

        public override string GetPassword(string username, string answer)
        {
            throw new NotImplementedException();
        }

        public override MembershipUser GetUser(string username, bool userIsOnline)
        {
            throw new NotImplementedException();
        }

        public override MembershipUser GetUser(object providerUserKey, bool userIsOnline)
        {
            throw new NotImplementedException();
        }

        public override string GetUserNameByEmail(string email)
        {
            throw new NotImplementedException();
        }

        public override int MaxInvalidPasswordAttempts
        {
            get { throw new NotImplementedException(); }
        }

        public override int MinRequiredNonAlphanumericCharacters
        {
            get { throw new NotImplementedException(); }
        }

        public override int MinRequiredPasswordLength
        {
            get { throw new NotImplementedException(); }
        }

        public override int PasswordAttemptWindow
        {
            get { throw new NotImplementedException(); }
        }

        public override MembershipPasswordFormat PasswordFormat
        {
            get { throw new NotImplementedException(); }
        }

        public override string PasswordStrengthRegularExpression
        {
            get { throw new NotImplementedException(); }
        }

        public override bool RequiresQuestionAndAnswer
        {
            get { throw new NotImplementedException(); }
        }

        public override bool RequiresUniqueEmail
        {
            get { throw new NotImplementedException(); }
        }

        public override string ResetPassword(string username, string answer)
        {
            throw new NotImplementedException();
        }

        public override bool UnlockUser(string userName)
        {
            throw new NotImplementedException();
        }

        public override void UpdateUser(MembershipUser user)
        {
            throw new NotImplementedException();
        }

    }
}