﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MvcSecurityExample.Models;
using MvcSecurityExample.Provider;

namespace MvcSecurityExampleInitData
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                ClearDB();
                InitDB();
                Console.WriteLine("База данных успешно инициализирована.");
                Console.ReadLine();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                Console.ReadLine();
            }
        }

        static void ClearDB()
        {
            MvcSecurityExampleModelContainer db = new MvcSecurityExampleModelContainer();

            foreach (var x in db.Users.ToList())
            {
                db.Users.DeleteObject(x);
            }

            foreach (var x in db.Groups)
            {
                db.Groups.DeleteObject(x);
            }

            db.SaveChanges();
        }

        static void InitDB()
        {
            MvcSecurityExampleModelContainer db = new MvcSecurityExampleModelContainer();

            Group gu = new Group()
            {
                GroupLabel = "Пользователи", 
                GroupName = "users"
            };

            Group ga = new Group()
            {
                GroupLabel = "Администраторы",
                GroupName = "admins"
            };

            User user = new User()
            {
                Name = "Иванов И.И.",
                Login = "user", 
                Password = CustomMembershipProvider.HashPassword("user"), 
                Group = gu
            };

            User admin = new User()
            {
                Name = "Петров П.П.",
                Login = "admin",
                Password = CustomMembershipProvider.HashPassword("admin"),
                Group = ga
            };

            db.Groups.AddObject(gu);
            db.Groups.AddObject(ga);
            db.Users.AddObject(user);
            db.Users.AddObject(admin);
            db.SaveChanges();
        }

    }
}
